; Zombie test
; /Mic 2004
;
; Assemble with WLA-DX


.define PAGE_SIZE $4000

.memorymap
	defaultslot 0

	slotsize PAGE_SIZE
	slot 0 0
	slot 1 PAGE_SIZE
	
	slotsize $8000
	slot 2 $8000
.endme


.rombanksize $4000
.rombanks 2


.bank 0
.org $0000


di
im 1
ld sp,$dff0				; Set stack pointer
jp main


; IRQ handler
.org $0038
	di
	jp vblank_routine


; NMI handler	
.org $0066
	retn


.org $0100

main:
	ld a,$14			; Bitmapped mode, 8bpp
	ld ($FF00),a

	; Set VRAM pointer to $12C00 (palette memory)
	ld a,$00
	ld ($FF10),a			; $FF10 = GPU address register
	ld a,$2C
	ld ($FF10),a
	ld a,$01
	ld ($FF10),a
	ld a,$00
	ld ($FF10),a
	
	ld de,$FF11			; $FF11 = GPU data register
	ld hl,palette+PAGE_SIZE
	ld b,0
	ld c,2
	set_palette:
		ld a,(hl)
		ld (de),a
		inc hl
		dec b
		jr nz,set_palette
		dec c
		jr nz,set_palette

	ld a,$80
	ld ($FF10),a
	ld a,$7F			; $7F80 = 320*102
	ld ($FF10),a
	ld a,$00
	ld ($FF10),a
	ld ($FF10),a
	
	ld hl,img+PAGE_SIZE
	ld b,0
	ld c,45
	load_img:
		ld a,(hl)
		ld ($FF11),a
		inc hl
		dec b
		jr nz,load_img
		dec c
		jr nz,load_img

	ld a,$B4
	ld ($FF00),a			; Enable vblank, enable display, use bitmapped mode, 8bpp
	
	ei				; Enable interrupts

	forever:
		jp forever		; Sit and wait for interrupts





vblank_routine:
	ld a,($FF01)			; Read GPU register 1, vblank flag is cleared
	and $80
	jr z,hblank
	
	
	hblank:
	ei
	reti
	
	
.bank 1
.org $0000

img:
	.incbin "xgs2_8.bin"
palette:
	.incbin "xgs2_8.pal"


			


	